<template>
    <div class="row px-4  ">
        <template v-if="userId && !isWishListCatalog" >
            <div class="col">
                <button class="btn btn-danger" v-if="wishlistData.includes(product.id)" @click.prevent="removeFromWishlist">Remove from Wishlist</button>
                <button class="btn btn-success" v-else  @click.prevent="addToWishList">Add to Wishlist</button>
            </div>
        </template>
        <template v-if="!userId && !isWishListCatalog">
            <div class="col">
                <button class="btn btn-info"  @click.prevent="redirectToLogin">Login to Add Wishlist</button>
            </div>
        </template>
        <template v-if="isWishListCatalog ">
            <div class="col align-left">
                <a @click.prevent="hitLikes" data-toggle="tooltip" data-placement="top" title="Click to Like Product">Like
                    <svg class="svg-icon green" viewBox="0 0 800 904" tooltip = "Help">
                        <path d="M582 324c1.333 4 20.667 8.333 58 13s73.333 12.667 108 24 52 27 52 47c0 48-20.333 142.667-61 284s-76.333 212-107 212c-96 0-192-14-288-42s-144-57.333-144-88V432c0-9.333 5-20.667 15-34 10-13.333 25.333-28.333 46-45s38.333-30.333 53-41c14.667-10.667 35.333-25 62-43s42-28.333 46-31c33.333-22.667 68-56 104-100s64.333-78.667 85-104 34.333-34 41-26c32 50.667 41.667 96.333 29 137-12.667 40.667-32.333 80.333-59 119s-40 58.667-40 60m-432 4c9.333 0 9.333 4.667 0 14-33.333 33.333-50 68-50 104v318c0 33.333 17.333 68 52 104 6.667 6.667 6 10-2 10-17.333 0-35.667-2.667-55-8s-40-20.333-62-45-33-57.667-33-99V484c0-41.333 11-74.667 33-100s43-41 63-47 38-9 54-9"></path>
                    </svg>
                </a>
            </div>
            <div class="col align-right ">
                <a @click.prevent="hitdislikes" data-toggle="tooltip" data-placement="top" title="Click to Dislike Product">Dislike
                    <svg class="svg-icon fill-red" viewBox="0 0 800 906" tooltip = "Help">
                        <path  d="M218 582c-1.333-4-20.333-8.333-57-13s-72.667-12.667-108-24-53-27-53-47c0-48 20.667-143 62-285S138.667 0 168 0c96 0 192 14.333 288 43s144 58.333 144 89v342c0 6.667-2.667 14.667-8 24s-13.667 19.333-25 30c-11.333 10.667-22 20.333-32 29-10 8.667-24 19.333-42 32-18 12.667-31.667 22.333-41 29-9.333 6.667-23 16-41 28l-33 22c-33.333 22.667-68 56-104 100s-64.333 78.667-85 104-34.333 34-41 26c-32-50.667-41.667-96.333-29-137 12.667-40.667 32.333-80.333 59-119s40-58.667 40-60m432-4c-8 0-7.333-4.667 2-14 32-33.333 48-68 48-104V142c0-33.333-17.333-68-52-104-6.667-6.667-6-10 2-10 17.333 0 35.667 2.667 55 8s40 20.333 62 45 33 57.667 33 99v242c0 32-6 59-18 81s-27 38-45 48-34 17-48 21-27 6-39 6"></path>
                    </svg>
                </a>
            </div>
        </template>
    </div>
</template>
<script>
    export default {
        name: 'wishlist',
        props: {
            userId:{
                type: Number,
                default: null
            },
            product:{
                type: Object,
                default: null
            },
            wishlistData:{
                default: null
            },
            isWishListCatalog:{
                type: Boolean,
                default: false
            },
            wishlistUserId: {
                type: Number,
                default: null
            },
        },

        data: function() {
            return {
                showWishlist: false
            }
        },
        methods: {
            addToWishList: function (product) {
                let self = this;
                let wishlistUrl = '/api/mywishlist';
                if(self.userId){
                    let postData = {
                        "user_id" : self.userId,
                        "product_id" : self.product.id
                    };
                    axios.post(wishlistUrl,postData)
                    .then(response => {
                        this.wishlistData.push(response.data.product_id);
                        this.$notify({
                            group: 'notify',
                            type: 'success',
                            title: 'Product Addition Success',
                            text: 'Product has been added into wishlist.'
                        });
                    }).catch(response => {
                        this.$notify({
                            group: 'notify',
                            type: 'error',
                            title: 'Product Removal Error',
                            text: 'Error when Adding the product from the wishlist.'
                        });
                    });
                }
            },
            removeFromWishlist: function(product) {
                let self = this;
                let wishlistUrl = '/api/remove-wishlist';
                if(self.userId){
                    let postData = {
                        "user_id" : self.userId,
                        "product_id" : self.product.id
                    };
                    axios.post(wishlistUrl,postData)
                    .then(response => {
                        if(response){
                            this.$notify({
                                group: 'notify',
                                type: 'success',
                                title: 'Product Removal Success',
                                text: 'Product has been removed from wishlist.'
                            });
                            let productIndex = self.wishlistData.indexOf(self.product.id)
                            self.wishlistData.splice(productIndex,1);
                            if(this.$parent.$parent.wishlistUserId){
                                this.$parent.$parent.fetchWishlistData();
                            }
                        }
                    }).catch(response => {
                        this.$notify({
                            group: 'notify',
                            type: 'error',
                            title: 'Product Removal Error',
                            text: 'Error when removing the product from the wishlist.'
                        });
                    });
                }
            },

            redirectToLogin: function () {
                window.location.href ='/login';
            },
            hitLikes : function () {
                let self = this;
                let hitLikesUrl = '/api/hit-likes';
                if(self.wishlistUserId){
                    let postData = {
                        "user_id" : self.wishlistUserId,
                        "product_id" : self.product.id
                    };
                    axios.post(hitLikesUrl,postData)
                    .then(response => {
                        this.$notify({
                            group: 'notify',
                            type: 'success',
                            title: 'Like',
                            text: 'You Liked the Product.'
                        });
                    }).catch(response => {
                        this.$notify({
                            group: 'notify',
                            type: 'error',
                            title: 'Product Like Error',
                            text: 'Error when Like to product from the wishlist.'
                        });
                    });
                }
            },
            hitdislikes : function () {
                let self = this;
                let hitLikesUrl = '/api/hit-dislikes';
                if(self.wishlistUserId){
                    let postData = {
                        "user_id" : self.wishlistUserId,
                        "product_id" : self.product.id
                    };
                    axios.post(hitLikesUrl,postData)
                        .then(response => {
                            this.$notify({
                                group: 'notify',
                                type: 'success',
                                title: 'Dislike',
                                text: 'You Disliked the Product.'
                            });
                        }).catch(response => {
                        this.$notify({
                            group: 'notify',
                            type: 'error',
                            title: 'Product Dislike Error',
                            text: 'Error when Dislike to product in the wishlist.'
                        });
                    });
                }
            }
        }
    }

</script>
<style>
    a{
        cursor: pointer;
    }
</style>